<?php
/**
*
* @package phpBB3
* @version $Id$
* @copyright (c) 2008 xceler8shun
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
* Borrowed from evil3 troll mod
*/

/**
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
define('IN_INSTALL_SEPERATE_LOGIN_USERNAME', true);
define('DEBUG', true);
define('DEBUG_EXTRA', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup(array('acp/common', 'install'));
$user->add_lang('mods/seperate_login_username');
$user->add_lang('mods/info_acp_seperate_login_username');

// We cant require admin level access to run the mod as we have changed the login script and users will be unable to login until the install script in executed.
// Otherwise we would enable the removed code below...
// Have they authenticated (again) as an admin for this session?
//if (!isset($user->data['session_admin']) || !$user->data['session_admin'])
//{
//	login_box('', $user->lang['LOGIN_ADMIN_CONFIRM'], $user->lang['LOGIN_ADMIN_SUCCESS']);
//}

// Is user any type of admin? No, then stop here, each script needs to
// check specific permissions but this is a catchall
//if (!$auth->acl_get('a_'))
//{
//	trigger_error('NO_ADMIN');
//}

// check for minimum php version
//if (version_compare(PHP_VERSION, '5.0.0') < 0)
//{
//	trigger_error('The  MOD requires a minimum PHP version of 5.0.0.', E_USER_WARNING);
//}

// some more includes
include($phpbb_root_path . 'install/functions_install.' . $phpEx);
include($phpbb_root_path . 'includes/db/db_tools.' . $phpEx);

// setup db tools
$db_tools = new phpbb_db_tools($db);

// Set custom template for admin area
$template->set_custom_template($phpbb_root_path . 'install/style', 'install');
$template->assign_var('T_TEMPLATE_PATH', $phpbb_root_path . 'install/style');

$mode = request_var('mode', '');

$seperate_login_username_version = '0.0.4';

// init
$error = array();

$page_body = '';
$page_body .= $user->lang['SEPERATE_LOGIN_USERNAME_MOD_EXPLAIN'] . '<br /><br />';

switch ($mode)
{
	case 'delete':

	    if (!is_writable("{$phpbb_root_path}install/"))
	    {
	        $page_body .= $user->lang['CANNOT_DELETE'] . '<br /><br />';
			$page_body .= sprintf($user->lang['RETURN_INSTALL'], '<a href="' . append_sid("{$phpbb_root_path}install/index.$phpEx") . '">', '</a>');
			break;
		}

		// attempt to delete the file itself
		delete_dir($phpbb_root_path . 'install/');
		redirect("{$phpbb_root_path}index.$phpEx");

	break;

	case 'install':

		if (isset($config['seperate_login_username_version']))
		{
			$page_body .= $user->lang['ALREADY_INSTALLED'] . '<br /><br />';
			$page_body .= sprintf($user->lang['RETURN_INSTALL'], '<a href="' . append_sid("{$phpbb_root_path}install/index.$phpEx") . '">', '</a>');
			break;
		}

		$install_data = array(
			'add_permissions'	=> array(false, array('a_loginnames', 'u_chgloginname')),		
			'load_schema'		=> $phpbb_root_path . 'install/schemas/',
			'install_modules'	=> array(
				array('acp', 'acp_disallow_loginnames', 'ACP_CAT_USERGROUP'),
			),
			'set_config'		=> array(
				array('allow_loginnamechange', 0, 0),
				array('max_loginname_chars', 20, 0),
				array('min_loginname_chars', 3, 0),
				array('allow_loginname_chars', 'LOGINNAME_CHARS_ANY', 0),
			),
		);
		$db_tools->sql_column_exists(USERS_TABLE, 'loginname');
		$db_tools->sql_column_add(USERS_TABLE, 'loginname', array('VCHAR', ''));
		$db_tools->sql_column_exists(USERS_TABLE, 'loginname_clean');
		$db_tools->sql_column_add(USERS_TABLE, 'loginname_clean', array('VCHAR', ''));
		
		 			
		$sql = 'UPDATE ' . USERS_TABLE . ' 
			SET loginname = username ';
		$db->sql_query($sql);
		
		$sql = 'UPDATE ' . USERS_TABLE . ' 
			SET loginname_clean = username_clean ';
		$db->sql_query($sql);

		process_install($install_data, $error, $db_tools);

		$page_body .= '<br /><br />';
		$page_body .= $user->lang['SEPERATE_LOGIN_USERNAME_MOD_INSTALLED'] . '<br /><br />';
		$page_body .= sprintf($user->lang['RETURN_INSTALL'], '<a href="' . append_sid("{$phpbb_root_path}install/index.$phpEx") . '">', '</a>');

		set_config('seperate_login_username_version', $seperate_login_username_version);

		// purge cache
		$cache->purge();
		$auth->acl_clear_prefetch();
		add_log('admin', 'LOG_MODULE_ADD', $user->lang['ACP_DISALLOW_LOGINNAMES']);		

	break;

	default:

		$page_body .= '<br /><br />';

		if (!isset($config['seperate_login_username_version']))
		{
			$page_body .= '<a href="' . append_sid("{$phpbb_root_path}install/index.$phpEx", 'mode=install') . '">&raquo; ' . $user->lang['INSTALL'] . '</a><br />';
		}
		else if (version_compare($config['seperate_login_username_version'], $seperate_login_username_version, '<'))
		{
			$page_body .= '<a href="' . append_sid("{$phpbb_root_path}install/index.$phpEx", 'mode=update') . '">&raquo; ' . $user->lang['UPDATE'] . '</a><br />';
		}
		else
		{
			$page_body .= $user->lang['NOTHING_TO_INSTALL'] . '<br /><br />';
			$page_body .= sprintf($user->lang['RETURN_INDEX'], '<a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">', '</a>');

			if (is_writable("{$phpbb_root_path}install/"))
			{
				$page_body .= '<br /><br />' . sprintf($user->lang['DELETE_SELF'], '<a href="' . append_sid("{$phpbb_root_path}install/index.$phpEx", 'mode=delete') . '">', '</a>');
			}
		}

	break;
}

// Assign index specific vars
$template->assign_vars(array(
	'TITLE'	=> $user->lang['SEPERATE_LOGIN_USERNAME_MOD'],
	'BODY'	=> $page_body,
));

// Output page
page_header($user->lang['INSTALL_PANEL']);

$template->set_filenames(array(
	'body' => 'install_main.html')
);

page_footer();

?>
